!
subroutine DF16(X, Y, XX, DY, Error)
!   DY  Y(X)
!   X1 ... XN   .
real, intent(in):: X(:), Y(:), XX
real:: DY, Hm, Hn, Hp, Xm, Xn, Xp, Ym, Yn, Yp, T
integer:: Error, k, n, L, R
!begin
  n=size(X)
  if(n<3) then
    Error=65; return
  end if
  Error=0
  L=1; R=n
  do while(L+1<R)
    k=(L+R)/2
    if(X(k)<=XX) then; L=k
                 else; R=k
    end if
  end do
  if(XX<=X(L)) then
    if(L==1) then
      DY=(Y(2)-Y(1))/(X(2)-X(1)) - &
         (Y(3)-Y(2))/(X(3)-X(2)) + (Y(3)-Y(1))/(X(3)-X(1))
    else
      DY=(Y(L)-Y(L-1))/(X(L)-X(L-1)) + &
         (Y(L+1)-Y(L))/(X(L+1)-X(L)) - (Y(L+1)-Y(L-1))/(X(L+1)-X(L-1))
    end if
    return
  end if
  if(L==1) then
    Xm=X(1); Xn=X(2); Xp=X(3)
    Ym=Y(1); Yn=Y(2); Yp=Y(3)
  else if(R==n) then
    if(XX>=X(n)) then
      DY=-(Y(n-1)-Y(n-2))/(X(n-1)-X(n-2)) + &
         (Y(n)-Y(n-1))/(X(n)-X(n-1)) + (Y(n)-Y(n-2))/(X(n)-X(n-2))
      return
    end if
    Xm=X(n-2); Xn=X(n-1); Xp=X(n)
    Ym=Y(n-2); Yn=Y(n-1); Yp=Y(n)
  else if(XX-X(L) <= X(R)-XX) then
    Xm=X(L-1); Xn=X(L); Xp=X(R)
    Ym=Y(L-1); Yn=Y(L); Yp=Y(R)
  else
    Xm=X(L); Xn=X(R); Xp=X(R+1)
    Ym=Y(L); Yn=Y(R); Yp=Y(R+1)
  end if
  Hm=Xn-Xm; Hn=Xp-Xm; Hp=Xp-Xn
  T=2.0*XX-Xm-Xp
  DY=(-Hn*T*Yn + Hp*(T-Hm)*Ym + Hm*(T+Hp)*Yp)/(Hm*Hn*Hp)
  return
end subroutine DF16
